from PyQt5.QtWidgets import QMainWindow, QApplication, QListWidgetItem, QCheckBox, QFileDialog
from PyQt5.QtCore import QThread, pyqtSignal, QSize
from PyQt5.QtGui import QMovie
import tkinter as tk
import threading
import time
from tkinter import filedialog
from Isocm import *
import sys
sys.path.append("..")
from ui.IsocmUi import Ui_MainWindow_isocm
import global_var

global_var._init()
global_var.set_value('isocm_end_flag',0)

class QSSLoader:
    def __init__(self):
        pass
    def read_qss_file(qss_file_name):
        with open(qss_file_name, 'r', encoding='UTF-8') as file:
            return file.read()

class IsocmThread(threading.Thread):
    def __init__(self):
        threading.Thread.__init__(self)
        self.event = threading.Event()
        self.pause()

    def run(self):
        while True:
            if self.event.isSet() == True:
                inputiso = global_var.get_value('inputiso')
                outputiso = global_var.get_value('outputiso')
                rpms_path = global_var.get_value('rpms_path')
                Isocm(inputiso, outputiso,rpms_path)

    def pause(self):
        self.event.clear()

    def resume(self):
        self.event.set()

class MonitorThread(threading.Thread):
    def __init__(self,IsocmWindow):
        threading.Thread.__init__(self)
        self.IsocmWindow = IsocmWindow
        self.event = threading.Event()
        self.pause()

    def run(self):
        while 1:
            if self.event.isSet() == True:
                isocm_end_flag = global_var.get_value('isocm_end_flag')
                if isocm_end_flag == 1:
                    outputiso = global_var.get_value('outputiso')
                    if os.path.isfile(outputiso):
                        isocm_thread.pause()
                        self.IsocmWindow.stackedWidget.setCurrentIndex(5)
                        self.IsocmWindow.label_5.setStyleSheet("font-size: 10px;"
                                                   "font-style: italic;"
                                                   "font-weight: bold;"
                                                   "color: #212121;"
                                                   "background-color:#ffffff;")
                        self.IsocmWindow.label_85.setStyleSheet("font-size: 10px;"
                                                    "font-style: italic;"
                                                    "font-weight: bold;"
                                                    "color: #212121;"
                                                    "background-color:#ffffff;")
                        self.IsocmWindow.label_4.setStyleSheet("font-size: 10px;"
                                                   "font-style: italic;"
                                                   "font-weight: bold;"
                                                   "color: #455A64;"
                                                   "background-color:#757575;")
                        self.IsocmWindow.label_84.setStyleSheet("font-size: 10px;"
                                                    "font-style: italic;"
                                                    "font-weight: bold;"
                                                    "color: #455A64;"
                                                    "background-color:#757575;")
                        self.IsocmWindow.pushButton_last.setEnabled(False)
                        self.IsocmWindow.pushButton_next.setEnabled(False)
                        global_var.set_value('isocm_end_flag',0)
                        sys.exit()
                    else:
                        isocm_thread.pause()
                        logging.error("构建失败，请检查配置项后重试!!!")
                        self.IsocmWindow.label_8.setText("构建失败！！！")
                        self.IsocmWindow.label_loading.setHidden(True)
                        self.IsocmWindow.pushButton_last.setEnabled(False)
                        self.IsocmWindow.pushButton_next.setEnabled(False)
                        global_var.set_value('isocm_end_flag', 0)
                        sys.exit()

    def pause(self):
        self.event.clear()

    def resume(self):
        self.event.set()


class LogThread(QThread):
    signal = pyqtSignal(str)
    def __init__(self):
        QThread.__init__(self)
    def run(self):
        f = open('/var/log/nfs-isocm.log', 'r')
        while 1:
            where = f.tell()
            line = f.readline()
            if not line:
                time.sleep(1)
                f.seek(where)
            else:
                self.signal.emit(line)

class IsocmWindow(QMainWindow, Ui_MainWindow_isocm):
    def __init__(self):
        super().__init__()
        self.setupUi(self)
        self.show()
        self.pushButton_isoname.clicked.connect(self.chose_iso)
        self.pushButton_pkgs.clicked.connect(self.chose_pkgs)
        self.pushButton_outputdir.clicked.connect(self.chose_outputdir)
        self.pushButton_last.clicked.connect(self.last_step)
        self.pushButton_next.clicked.connect(self.next_step)
        self.pushButton_exit.clicked.connect(self.exit)
        self.pushButton_confirm_input.clicked.connect(self.confirm_input)
        self.pushButton_confirm_template.clicked.connect(self.confirm_template)
        self.pushButton_confirm_import.clicked.connect(self.confirm_import)
        self.pushButton_ok.clicked.connect(self.exit)
        self.pushButton_goto_iso.clicked.connect(self.goto_iso)
        self.loading_show()

    def chose_iso(self):
        root = tk.Tk()
        root.withdraw()
        self.f_path = filedialog.askopenfilename()
        if len(self.f_path) != 0:
            self.lineEdit_isoname.setText(self.f_path)

    def chose_pkgs(self):
        root = tk.Tk()
        root.withdraw()
        f_path = filedialog.askdirectory()
        if len(f_path) != 0:
            self.lineEdit_pkgs.setText(f_path)

    def chose_outputdir(self):
        root = tk.Tk()
        root.withdraw()
        f_path = filedialog.askdirectory()
        if len(f_path) != 0:
            self.lineEdit_outputdir.setText(f_path)

    def last_step(self):
        current_index = self.stackedWidget.currentIndex()
        print(current_index)
        if current_index == 1:
            self.pushButton_last.setEnabled(False)
        current_label= "label_" + str(current_index)
        current_num_label= "label_8" + str(current_index)
        current_label_attr = getattr(self,current_label)
        current_num_label_attr = getattr(self,current_num_label)
        current_label_attr.setStyleSheet("font-size: 10px;"
                               "font-style: italic;"
                               "font-weight: bold;"
                               "color: #FFFFFF;"
                               "background-color:#607D8B;")
        current_num_label_attr.setStyleSheet("font-size: 10px;"
                               "font-style: italic;"
                               "font-weight: bold;"
                               "color: #FFFFFF;"
                               "background-color:#607D8B;")
        last_index = self.stackedWidget.currentIndex() - 1
        last_label= "label_" + str(last_index)
        last_num_label= "label_8" + str(last_index)
        last_label_attr = getattr(self,last_label)
        last_num_label_attr = getattr(self,last_num_label)
        last_label_attr.setStyleSheet("font-size: 10px;"
                               "font-style: italic;"
                               "font-weight: bold;"
                               "color: #212121;"
                               "background-color:#ffffff;")
        last_num_label_attr.setStyleSheet("font-size: 10px;"
                               "font-style: italic;"
                               "font-weight: bold;"
                               "color: #212121;"
                               "background-color:#ffffff;")
        self.stackedWidget.setCurrentIndex(current_index - 1)

    def next_step(self):
        current_index = self.stackedWidget.currentIndex()
        current_label = "label_" + str(current_index)
        current_num_label = "label_8" + str(current_index)
        current_label_attr = getattr(self, current_label)
        current_num_label_attr = getattr(self, current_num_label)
        current_label_attr.setStyleSheet("font-size: 10px;"
                               "font-style: italic;"
                               "font-weight: bold;"
                               "color: #455A64;"
                               "background-color:#757575;")
        current_num_label_attr.setStyleSheet("font-size: 10px;"
                               "font-style: italic;"
                               "font-weight: bold;"
                               "color: #455A64;"
                               "background-color:#757575;")
        next_index = self.stackedWidget.currentIndex()+1
        label= "label_" + str(next_index)
        label1 = "label_8" + str(next_index)
        labeltmp = getattr(self,label)
        labeltmp1 = getattr(self, label1)
        labeltmp.setStyleSheet("font-size: 10px;"
                               "font-style: italic;"
                               "font-weight: bold;"
                               "color: #212121;"
                               "background-color:#ffffff;")
        labeltmp1.setStyleSheet("font-size: 10px;"
                               "font-style: italic;"
                               "font-weight: bold;"
                               "color: #212121;"
                               "background-color:#ffffff;")
        self.stackedWidget.setCurrentIndex(next_index)
        self.JudgeIndex()

    def RefreshList(self,file):
        self.listWidget.clear()
        f = open(file)
        for line in f:
            box = QCheckBox(line)
            item = QListWidgetItem()
            self.listWidget.addItem(item)
            box.setChecked(True)
            self.listWidget.setItemWidget(item, box)
        f.close

    def Confirm_List(self,file):
        count = self.listWidget.count()
        rpmlist = [self.listWidget.itemWidget(self.listWidget.item(i)) for i in range(count)]
        fp = open(file, "w+")
        for rpm in rpmlist:
            if rpm.isChecked():
                text = rpm.text().replace("\n", "")
                print(text, file=fp)

    def JudgeIndex(self):
        index = self.stackedWidget.currentIndex()
        if index == 1:
            self.pushButton_last.setEnabled(True)
        if index == 2:
            cmd = "cp -av /etc/nfs-isocm/rpmlist-tmp /etc/nfs-isocm/template/默认包列表模板"
            ret = ICONFIG.run_cmd(cmd)
            if ret == 0:
                logging.error("默认包列表拷贝失败")
                sys.exit()
            self.comboBox.clear()
            self.comboBox.addItem("默认包列表模板")
            for files in os.listdir("/etc/nfs-isocm/template"):
                if files != "默认包列表模板":
                    self.comboBox.addItem(files)
            self.RefreshList("/etc/nfs-isocm/template/默认包列表模板")
        if index == 3:
            self.Confirm_List("/etc/nfs-isocm/rpmlist")
        if index == 4:
            inputiso = self.lineEdit_isoname.text()
            global_var.set_value('inputiso',inputiso)
            outputdir = self.lineEdit_outputdir.text()
            global_var.set_value('outputdir',outputdir)
            outputiso = outputdir + "/" + self.lineEdit_outputiso.text()
            global_var.set_value('outputiso',outputiso)
            os.system("echo > /var/log/nfs-isocm.log")
            rpms_path = self.lineEdit_pkgs.text()
            global_var.set_value('rpms_path',rpms_path)
            isocm_thread.start()
            isocm_thread.resume()
            self.log_thread = LogThread()
            self.log_thread.signal.connect(self.append_line)
            self.log_thread.start()
            monitor_thread.start()
            monitor_thread.resume()

    def append_line(self,line):
        line = line.strip('\n')
        self.textBrowser.append(line)

    def confirm_input(self):
        template = self.comboBox.currentText()
        template = "/etc/nfs-isocm/template/" + template
        rpmname = self.lineEdit_rpm_name.text()
        self.lineEdit_rpm_name.setText("")
        with open(template,'a+') as f:
            f.write(rpmname+'\n')
        self.RefreshList(template)

    def loading_show(self):
        self.loading_gif = QMovie('/opt/nfs-isocm/ui/images/loading.gif')
        self.loading_gif_size = QSize(self.label_loading.width(),self.label_loading.height())
        self.loading_gif.setScaledSize(self.loading_gif_size)
        self.label_loading.setMovie(self.loading_gif)
        self.loading_gif.start()

    def confirm_template(self):
        template = self.lineEdit_template.text()
        template = "/etc/nfs-isocm/template/" + template
        self.Confirm_List(template)
        self.lineEdit_template.setText("")
        self.comboBox.clear()
        self.comboBox.addItem("默认包列表模板")
        for files in os.listdir("/etc/nfs-isocm/template"):
            if files != "默认包列表模板":
                self.comboBox.addItem(files)

    def confirm_import(self):
        template = self.comboBox.currentText()
        template = "/etc/nfs-isocm/template/" + template
        self.RefreshList(template)
        print(template)

    def goto_iso(self):
        outputdir = self.lineEdit_outputdir.text()
        QFileDialog.getOpenFileNames(self,"镜像所在位置",outputdir)

    def exit(self):
        sys.exit(app.exec_())

app = QApplication(sys.argv)
IsocmWindow = IsocmWindow()
style_file = '/opt/nfs-isocm/ui/Aqua.qss'
style_sheet = QSSLoader.read_qss_file(style_file)
IsocmWindow.setStyleSheet(style_sheet)
isocm_thread = IsocmThread()
monitor_thread = MonitorThread(IsocmWindow)
IsocmWindow.show()
sys.exit(app.exec())
